## linux-firmware-raspi2 1.20200212

=== hardfp/opt/vc/src/hello_pi/hello_font/Makefile ===
OBJS=main.o
BIN=hello_font.bin

LDFLAGS+=-lvgfont -lfreetype -lz -lrevision

include ../Makefile.include

=== hardfp/opt/vc/src/hello_pi/hello_triangle/Makefile ===
OBJS=triangle.o
BIN=hello_triangle.bin

LDFLAGS+= -lrevision

include ../Makefile.include

=== hardfp/opt/vc/src/hello_pi/hello_triangle2/Makefile ===
OBJS=triangle2.o
BIN=hello_triangle2.bin

LDFLAGS+= -lrevision

include ../Makefile.include

=== hardfp/opt/vc/src/hello_pi/hello_videocube/Makefile ===
OBJS=triangle.o video.o
BIN=hello_videocube.bin
LDFLAGS+=-lilclient -lrevision

include ../Makefile.include

## linux-firmware-raspi2 1.20151118+b70b451

=== debian/changelog ===
linux-firmware-raspi2 (1.20151118+b70b451-0ubuntu1) xenial; urgency=low

  * Switch package naming to fall into the linux-firmware-* hierachy.
  * Move to section multiverse/misc.
  * Update standards version to 3.9.7 no changes required.
  * Check that /boot/firmware is a mount point (or that we are in a chroot).
  * We do not need to install LICENCE.broadcom.

 -- Andy Whitcroft <apw@ubuntu.com>  Wed, 20 Apr 2016 12:23:41 +0100

raspberrypi2-firmware (4.1.15-b70b451-0ubuntu1) xenial; urgency=medium

  * Initial upload to Ubuntu.
  * Add lintian overrides to suppress errors about known binary-only firmware.
  * Set upload component to restricted.
  * Fix inconsistency between upstream LICENSE file and debian/copyright.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 05 Feb 2016 01:06:55 +0000

raspberrypi2-firmware (4.1.15-b70b451-1) xenial; urgency=medium

  * Update to version 4.1.15 @ b70b451

 -- Paolo Pisati <paolo.pisati@canonical.com>  Fri, 08 Jan 2016 10:53:53 +0100

raspberrypi2-firmware (4.1.10-ba7a8fb-1) wily; urgency=low

  * Initial import - https://github.com/raspberrypi/firmware / master @ ba7a8fb

 -- Paolo Pisati <paolo.pisati@canonical.com>  Mon, 19 Oct 2015 15:34:09 +0200

=== debian/control ===
Source: linux-firmware-raspi2
Section: multiverse/misc
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.7
Homepage: https://github.com/raspberrypi/firmware

Package: linux-firmware-raspi2
Architecture: armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: RaspberryPi2 GPU firmware and bootloaders
 This package contains all the proprietary files necessary to boot a
 RaspberryPi2 board.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


# main packaging script based on dh7 syntax
%:
	dh $@ 

override_dh_install:
	dh_install
	rm debian/linux-firmware-raspi2/usr/lib/linux-firmware-raspi2/LICENCE.broadcom

# debmake generated override targets
# This is example for Cmake (See http://bugs.debian.org/641051 )
#override_dh_auto_configure:
#	dh_auto_configure -- \
#	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/linux-firmware-raspi2-$1\.tar\.gz/ \
  https://github.com/raspberrypi/firmware/releases .*/v?(\d\S*)\.tar\.gz

## linux-firmware-raspi2 1.20161020

=== debian/changelog ===
linux-firmware-raspi2 (1.20161020-0ubuntu1~1.1) yakkety; urgency=medium

  * Update to release 1.20161020
  * Check that config.txt sets the $device_tree_address, or forcefully set it to 0x02000000
    (LP: #1636838)

 -- Paolo Pisati <paolo.pisati@canonical.com>  Fri, 28 Oct 2016 14:41:31 +0200

## linux-firmware-raspi2 1.20190215

=== debian/changelog ===
linux-firmware-raspi2 (1.20190215-0ubuntu3) disco; urgency=medium

  * Updated d/copyright with comment about origin of bluetooth firmwares

 -- Dave Jones <dave.jones@canonical.com>  Thu, 11 Apr 2019 21:19:08 +0000

linux-firmware-raspi2 (1.20190215-0ubuntu2) disco; urgency=medium

  * Added firmwares for Bluetooth on Raspberry Pi 3B and 3B+ (LP: #1824338)
  * Fixed decoding of wifi firmware blob in prior patch

 -- Dave Jones <dave.jones@canonical.com>  Thu, 11 Apr 2019 12:07:10 +0000

linux-firmware-raspi2 (1.20190215-0ubuntu1) disco; urgency=medium

  * Update to release 1.20190215
  * New firmwares enable boot on Compute Module 3+

 -- Dave Jones <dave.jones@canonical.com>  Thu, 04 Apr 2019 14:27:52 +0000

linux-firmware-raspi2 (1.20180919-0ubuntu2) disco; urgency=medium

  * Do not install the kernel*.img binaries as they're not needed.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Mon, 28 Jan 2019 10:14:03 +0100

linux-firmware-raspi2 (1.20180919-0ubuntu1) disco; urgency=medium

  * Update to release 1.20180919
  * Add debian/patches/brcm_firmware patch from raspi3-firmware as the newer
    upstream firmware tarballs do not include all the required files for WiFi
    to be active on the raspi3.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Thu, 17 Jan 2019 15:43:21 +0100

linux-firmware-raspi2 (1.20161020-0ubuntu1) zesty; urgency=medium

  * Update to release 1.20161020
  * Check that config.txt sets the $device_tree_address, or forcefully set it to 0x02000000
    (LP: #1636838)

 -- Paolo Pisati <paolo.pisati@canonical.com>  Fri, 28 Oct 2016 14:41:31 +0200

=== debian/control ===
--- 
+++ 
@@ -7,8 +7,8 @@
 Homepage: https://github.com/raspberrypi/firmware
 
 Package: linux-firmware-raspi2
-Architecture: armhf
+Architecture: armhf arm64
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Description: RaspberryPi2 GPU firmware and bootloaders
+Description: RaspberryPi2/3 GPU firmware and bootloaders
  This package contains all the proprietary files necessary to boot a
- RaspberryPi2 board.
+ RaspberryPi2/3 board.

=== debian/rules ===
--- 
+++ 
@@ -23,7 +23,14 @@
 
 override_dh_install:
 	dh_install
+	# Decode the patched in blobs
+	base64 --decode brcm80211/brcmfmac43455-sdio.clm_blob.base64 > debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.clm_blob
+	base64 --decode bcm434/BCM43430A1.hcd.base64 > debian/linux-firmware-raspi2/lib/firmware/brcm/BCM43430A1.hcd
+	base64 --decode bcm434/BCM4345C0.hcd.base64 > debian/linux-firmware-raspi2/lib/firmware/brcm/BCM4345C0.hcd
+	# Some files don't need to be installed on the system
+	rm debian/linux-firmware-raspi2/usr/lib/linux-firmware-raspi2/COPYING.linux
 	rm debian/linux-firmware-raspi2/usr/lib/linux-firmware-raspi2/LICENCE.broadcom
+	rm debian/linux-firmware-raspi2/usr/lib/linux-firmware-raspi2/kernel*.img
 
 # debmake generated override targets
 # This is example for Cmake (See http://bugs.debian.org/641051 )

## linux-firmware-raspi2 1.20190819

=== debian/changelog ===
linux-firmware-raspi2 (1.20190819-0ubuntu2) eoan; urgency=medium

  * Update brcm43455 blob to support wifi on Pi 4 (LP: #1847782)
  * Remove redundant Pi 3 wireless config (now part of linux-firmware)

 -- Dave Jones <dave.jones@canonical.com>  Fri, 11 Oct 2019 10:58:51 +0100

linux-firmware-raspi2 (1.20190819-0ubuntu1) eoan; urgency=medium

  * Update to release 1.20190819 to enable Pi 4 boot (LP: #1847163)
  * Remove incorrect device_tree_address hack in postinst
  * Simplify copy of firmware to the boot partition in postinst

 -- Dave Jones <dave.jones@canonical.com>  Mon, 07 Oct 2019 22:24:41 +0100

=== debian/control ===
--- 
+++ 
@@ -9,6 +9,6 @@
 Package: linux-firmware-raspi2
 Architecture: armhf arm64
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Description: RaspberryPi2/3 GPU firmware and bootloaders
+Description: Raspberry Pi 2/3/4 GPU firmware and bootloaders
  This package contains all the proprietary files necessary to boot a
- RaspberryPi2/3 board.
+ Raspberry Pi 2/3/4 board.

## linux-firmware-raspi2 1.20200212

=== debian/changelog ===
linux-firmware-raspi2 (1.20200212-0ubuntu1) focal; urgency=medium

  * New upstream release, 1.20200212
  * Updated wifi firmware to support 802.11ac wifi (LP: #1862760)
  * Added diversions to override linux-firmware's versions of the wifi
    firmware (LP: #1862146)

 -- Dave Jones <dave.jones@canonical.com>  Tue, 10 Mar 2020 11:46:49 +0000

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 Package: linux-firmware-raspi2
 Architecture: armhf arm64
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}
 Description: Raspberry Pi 2/3/4 GPU firmware and bootloaders
  This package contains all the proprietary files necessary to boot a
  Raspberry Pi 2/3/4 board.

=== debian/rules ===
--- 
+++ 
@@ -19,18 +19,15 @@
 
 # main packaging script based on dh7 syntax
 %:
-	dh $@ 
+	dh $@
 
 override_dh_install:
 	dh_install
 	# Decode the patched in blobs
+	base64 --decode brcm80211/brcmfmac43455-sdio.bin.base64 > debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.bin
 	base64 --decode brcm80211/brcmfmac43455-sdio.clm_blob.base64 > debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.clm_blob
 	base64 --decode bcm434/BCM43430A1.hcd.base64 > debian/linux-firmware-raspi2/lib/firmware/brcm/BCM43430A1.hcd
 	base64 --decode bcm434/BCM4345C0.hcd.base64 > debian/linux-firmware-raspi2/lib/firmware/brcm/BCM4345C0.hcd
-	# Some files don't need to be installed on the system
-	rm debian/linux-firmware-raspi2/usr/lib/linux-firmware-raspi2/COPYING.linux
-	rm debian/linux-firmware-raspi2/usr/lib/linux-firmware-raspi2/LICENCE.broadcom
-	rm debian/linux-firmware-raspi2/usr/lib/linux-firmware-raspi2/kernel*.img
 
 # debmake generated override targets
 # This is example for Cmake (See http://bugs.debian.org/641051 )

## linux-firmware-raspi2 2

=== debian/changelog ===
linux-firmware-raspi2 (2-0ubuntu2) groovy; urgency=medium

  * Add extra copy of the BCM43456 wifi configuration

 -- Dave Jones <dave.jones@canonical.com>  Fri, 16 Oct 2020 10:34:13 +0100

linux-firmware-raspi2 (2-0ubuntu1) groovy; urgency=medium

  * Replace source tarballs from forked/merged RPi-Distro packages, to a
    3.0 quilt package that has empty orig tarball, and only includes the
    matching files shipped by the package, as component tarballs, without
    duplicating linux-firmware. See get-orig-source target. The resulting
    .deb is identical to the previous one, this only corrects the source
    package contents.
    Components are at:
     - boot - 1.20200902
     - bluez - c317a5c56847d18faf43e531f35c1661f1134046
     - nofree (wifi) - 98e815735e2c805d65994ccc608f399595b74438
  * Drop multiverse/ section for promotion to restricted.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 07 Oct 2020 12:59:05 +0100

linux-firmware-raspi2 (1.20200902-0ubuntu1) groovy; urgency=medium

  * Replaced postinst with flash-kernel trigger (relates to LP: #1895137)
  * New upstream boot firmware release, 1.20200902
  * New upstream bluetooth firmware release, 1.2-4+rpt5

    [ Serge Schneider ]
    - This BCM43438 and BCM43455 Bluetooth firmware updates work around most
      of the report "Spectra" class of vulnerabilities. CVE-2020-10370 will be
      addressed in a follow-up release.
    - Add BCM4345C5.hcd

  * New upstream wifi firmware release, 1:20190114-1+rpt8

    [ Phil Elwell ]
    - Add BCM43456 firmware
      - brcm/brcmfmac43456-sdio.bin 7.84.17.1
      - brcm/brcmfmac43456-sdio.clm_blob
      - brcm/brcmfmac43456-sdio.txt

    [ Serge Schneider ]
    - Update brcmfmac43455-sdio.bin to 7.45.206

 -- Dave Jones <dave.jones@canonical.com>  Fri, 18 Sep 2020 17:24:45 +0100

linux-firmware-raspi2 (1.20200601+arm64-0ubuntu3) groovy; urgency=medium

  * Rename BCM43456 configuration to include d-t compatible suffix

 -- Dave Jones <dave.jones@canonical.com>  Tue, 28 Jul 2020 09:56:03 +0100

linux-firmware-raspi2 (1.20200601+arm64-0ubuntu2) groovy; urgency=medium

  * Update bluez firmware to latest upstream version (1.2-4+rpt3)
    (LP: #1888211)
  * Change packaging to use multi-upstream tarballs
  * Add diversion for BCM43430 binary blob
  * Bumped compat to 11 and fixed dh_strip issue

 -- Dave Jones <dave.jones@canonical.com>  Fri, 17 Jul 2020 18:55:11 +0100

linux-firmware-raspi2 (1.20200601+arm64-0ubuntu1) groovy; urgency=medium

  * New upstream release, 1.20200601+arm64

 -- Dave Jones <dave.jones@canonical.com>  Mon, 08 Jun 2020 11:24:11 +0000

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# main packaging script based on dh7 syntax
%:
	dh $@

override_dh_install:
	dh_install
	mv debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43430-sdio.txt \
		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43430-sdio.raspberrypi,3-model-b.txt
	cp debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.txt \
		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.raspberrypi,3-model-b-plus.txt
	cp debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.txt \
		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.raspberrypi,4-model-b.txt
	rm debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.txt
	cp debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43456-sdio.txt \
		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43456-sdio.raspberrypi,4-model-b.txt
	cp debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43456-sdio.txt \
		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43456-sdio.raspberrypi,400.txt
	rm debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43456-sdio.txt

override_dh_strip:
	# Don't strip anything; it's all pre-built binary blobs and some of
	# it is foreign architecture anyway

BOOTCOMMIT:= 1.20200902
BOOTFILES := LICENCE.broadcom bootcode.bin fixup.dat fixup4.dat fixup4cd.dat fixup4db.dat fixup4x.dat fixup_cd.dat fixup_db.dat fixup_x.dat start.elf start4.elf start4cd.elf start4db.elf start4x.elf start_cd.elf start_db.elf start_x.elf

BTCOMMIT:= c317a5c56847d18faf43e531f35c1661f1134046
BTFILES := BCM43430A1.hcd BCM4345C0.hcd BCM4345C5.hcd

WIFICOMMIT:= 98e815735e2c805d65994ccc608f399595b74438
WIFIFILES := brcmfmac43430-sdio.bin brcmfmac43430-sdio.txt brcmfmac43455-sdio.bin brcmfmac43455-sdio.clm_blob brcmfmac43455-sdio.txt brcmfmac43456-sdio.bin brcmfmac43456-sdio.clm_blob brcmfmac43456-sdio.txt


get-orig-source:
	rm -rf boot bluez nonfree

	set -x; mkdir -p boot; cd boot; $(foreach file,$(BOOTFILES),wget https://github.com/raspberrypi/firmware/raw/$(BOOTCOMMIT)/boot/$(file);)

	set -x; mkdir -p bluez/broadcom; cd bluez/broadcom; $(foreach file,$(BTFILES),wget https://github.com/RPi-Distro/bluez-firmware/raw/$(BTCOMMIT)/broadcom/$(file);)

	set -x; mkdir -p nonfree/brcm/; cd nonfree/brcm; $(foreach file,$(WIFIFILES),wget https://github.com/RPi-Distro/firmware-nonfree/raw/$(WIFICOMMIT)/brcm/$(file);)
	cd nonfree; wget https://github.com/RPi-Distro/firmware-nonfree/raw/$(WIFICOMMIT)/LICENCE.broadcom_bcm43xx
	cd nonfree; wget https://github.com/RPi-Distro/firmware-nonfree/raw/$(WIFICOMMIT)/LICENCE.cypress

	mkdir $(DEB_SOURCE)-$(DEB_VERSION_UPSTREAM)
	tar -czf ../$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM).orig.tar.gz $(DEB_SOURCE)-$(DEB_VERSION_UPSTREAM)
	tar -czf ../$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM).orig-boot.tar.gz boot/
	tar -czf ../$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM).orig-bluez.tar.gz bluez/
	tar -czf ../$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM).orig-nonfree.tar.gz nonfree/
	rmdir $(DEB_SOURCE)-$(DEB_VERSION_UPSTREAM)

## linux-firmware-raspi2 4

=== debian/changelog ===
linux-firmware-raspi2 (4-0ubuntu0~18.04.1) bionic; urgency=medium

  * Backport to bionic (LP: #1940400)
    - Removed Breaks on flash-kernel and reinstated postinst to install boot
      firmware
    - Added diversions for all wifi firmware blobs
    - New upstream boot firmware release, 1.20210303
    - New upstream bluetooth firmware release, 1.2-4+rpt8

      [ Phil Elwell ]
      - Second Spectra fix for CYW43455 (CVE-2020-10370)
        - Original firmware name: BCM4345C0_003.001.025.0174.0342.hcd

    - New upstream wifi firmware release, 1:20190114-1+rpt11

      [ Serge Schneider ]
      - Update CYW43455 firmware
        - brcm/brcmfmac43455-sdio.bin 7.45.229
        - See: https://github.com/raspberrypi/linux/issues/3849

 -- Dave Jones <dave.jones@canonical.com>  Tue, 31 Aug 2021 15:43:35 +0100

linux-firmware-raspi2 (1.20200601+arm64-0ubuntu2~18.04.1) bionic; urgency=medium

  * SRU to bionic to support booting RPi 4B rev 1.4 (LP: #1886581)
  * Update bluez firmware to latest upstream version (1.2-4+rpt3)
    (LP: #1888211)
  * Change packaging to use multi-upstream tarballs
  * Add diversion for BCM43430 binary blob
  * Bumped compat to 11 and fixed dh_strip issue

 -- Dave Jones <dave.jones@canonical.com>  Fri, 17 Jul 2020 18:55:11 +0100

linux-firmware-raspi2 (1.20190819-0ubuntu0.18.04.1) bionic; urgency=medium

  * SRU to bionic to support booting RPi 4B (LP: #1847163)
    - Update to release 1.20190819
    - Include generic NVRAM configuration files for 4.x kernel series

 -- Dave Jones <dave.jones@canonical.com>  Fri, 20 Dec 2019 12:45:08 +0000

linux-firmware-raspi2 (1.20190215-0ubuntu0.18.04.1) bionic; urgency=medium

  * SRU to bionic to support booting RPi 3B+ and CM3+ (LP: #1761483)
    - Update to release 1.20190215
    - Added firmwares for Bluetooth on Raspberry Pi 3B and 3B+
    - Updated d/copyright with comment about origin of bluetooth firmwares

 -- Dave Jones <dave.jones@canonical.com>  Thu, 18 Jul 2019 12:27:29 +0000

linux-firmware-raspi2 (1.20180919-0ubuntu0.18.04.2) bionic; urgency=medium

  * Do not install the kernel*.img binaries as they're not needed.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Mon, 28 Jan 2019 10:23:26 +0100

linux-firmware-raspi2 (1.20180919-0ubuntu0.18.04.1) bionic; urgency=medium

  * Update to release 1.20180919 to match what is used in our official core18
    images. (LP: #1805668)
  * Add debian/patches/brcm_firmware patch from raspi3-firmware as the newer
    upstream firmware tarballs do not include all the required files for WiFi
    to be active on the raspi3.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Thu, 17 Jan 2019 15:43:21 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: linux-firmware-raspi2
-Section: multiverse/misc
+Section: misc
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.7
+Build-Depends: debhelper (>= 11)
+Standards-Version: 4.5.0
 Homepage: https://github.com/raspberrypi/firmware
+XS-Autobuild: yes
 
 Package: linux-firmware-raspi2
 Architecture: armhf arm64

=== debian/rules ===
--- 
+++ 
@@ -13,15 +13,24 @@
 
 override_dh_install:
 	dh_install
+
 	mv debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43430-sdio.txt \
 		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43430-sdio.raspberrypi,3-model-b.txt
+
 	cp debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.txt \
 		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.raspberrypi,3-model-b-plus.txt
 	cp debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.txt \
 		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.raspberrypi,4-model-b.txt
+	cp debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.txt \
+		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.raspberrypi,4-compute-module.txt
+	cp debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.txt \
+		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.raspberrypi,400.txt
 	rm debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.txt
+
 	cp debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43456-sdio.txt \
 		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43456-sdio.raspberrypi,4-model-b.txt
+	cp debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43456-sdio.txt \
+		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43456-sdio.raspberrypi,4-compute-module.txt
 	cp debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43456-sdio.txt \
 		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43456-sdio.raspberrypi,400.txt
 	rm debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43456-sdio.txt
@@ -30,15 +39,47 @@
 	# Don't strip anything; it's all pre-built binary blobs and some of
 	# it is foreign architecture anyway
 
-BOOTCOMMIT:= 1.20200902
-BOOTFILES := LICENCE.broadcom bootcode.bin fixup.dat fixup4.dat fixup4cd.dat fixup4db.dat fixup4x.dat fixup_cd.dat fixup_db.dat fixup_x.dat start.elf start4.elf start4cd.elf start4db.elf start4x.elf start_cd.elf start_db.elf start_x.elf
+BOOTCOMMIT:= 1.20210303
+BOOTFILES := \
+	LICENCE.broadcom \
+	bootcode.bin \
+	fixup.dat \
+	fixup4.dat \
+	fixup4cd.dat \
+	fixup4db.dat \
+	fixup4x.dat \
+	fixup_cd.dat \
+	fixup_db.dat \
+	fixup_x.dat \
+	start.elf \
+	start4.elf \
+	start4cd.elf \
+	start4db.elf \
+	start4x.elf \
+	start_cd.elf \
+	start_db.elf \
+	start_x.elf
 
-BTCOMMIT:= c317a5c56847d18faf43e531f35c1661f1134046
-BTFILES := BCM43430A1.hcd BCM4345C0.hcd BCM4345C5.hcd
+BTCOMMIT:= e7fd166981ab4bb9a36c2d1500205a078a35714d
+BTFILES := \
+	BCM43430A1.hcd \
+	BCM4345C0.hcd \
+	BCM4345C5.hcd \
+	BCM43430B0.hcd
 
-WIFICOMMIT:= 98e815735e2c805d65994ccc608f399595b74438
-WIFIFILES := brcmfmac43430-sdio.bin brcmfmac43430-sdio.txt brcmfmac43455-sdio.bin brcmfmac43455-sdio.clm_blob brcmfmac43455-sdio.txt brcmfmac43456-sdio.bin brcmfmac43456-sdio.clm_blob brcmfmac43456-sdio.txt
-
+WIFICOMMIT:= 83938f78ca2d5a0ffe0c223bb96d72ccc7b71ca5
+WIFIFILES := \
+	brcmfmac43430-sdio.bin \
+	brcmfmac43430-sdio.txt \
+	brcmfmac43436-sdio.bin \
+	brcmfmac43436-sdio.clm_blob \
+	brcmfmac43436-sdio.txt \
+	brcmfmac43455-sdio.bin \
+	brcmfmac43455-sdio.clm_blob \
+	brcmfmac43455-sdio.txt \
+	brcmfmac43456-sdio.bin \
+	brcmfmac43456-sdio.clm_blob \
+	brcmfmac43456-sdio.txt
 
 get-orig-source:
 	rm -rf boot bluez nonfree
@@ -50,6 +91,7 @@
 	set -x; mkdir -p nonfree/brcm/; cd nonfree/brcm; $(foreach file,$(WIFIFILES),wget https://github.com/RPi-Distro/firmware-nonfree/raw/$(WIFICOMMIT)/brcm/$(file);)
 	cd nonfree; wget https://github.com/RPi-Distro/firmware-nonfree/raw/$(WIFICOMMIT)/LICENCE.broadcom_bcm43xx
 	cd nonfree; wget https://github.com/RPi-Distro/firmware-nonfree/raw/$(WIFICOMMIT)/LICENCE.cypress
+	cd nonfree; wget https://github.com/RPi-Distro/firmware-nonfree/raw/$(WIFICOMMIT)/WHENCE
 
 	mkdir $(DEB_SOURCE)-$(DEB_VERSION_UPSTREAM)
 	tar -czf ../$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM).orig.tar.gz $(DEB_SOURCE)-$(DEB_VERSION_UPSTREAM)

## linux-firmware-raspi2 5

=== debian/changelog ===
linux-firmware-raspi2 (5-0ubuntu1) impish; urgency=medium

  * New upstream boot firmware release, 1.20210831
    - Contains workaround for compatibility with "full" KMS overlay on the
      Ubuntu Pi desktop (LP: #1944397)
  * Removed d/compat (replaced with debhelper-compat build-dep)

 -- Dave Jones <dave.jones@canonical.com>  Tue, 28 Sep 2021 21:04:23 +0100

linux-firmware-raspi2 (4-0ubuntu3) hirsute; urgency=medium

  * Add diversion for brcmfmac43430 clm_blob (LP: #1922257)

 -- Dave Jones <dave.jones@canonical.com>  Fri, 16 Apr 2021 00:12:35 +0100

linux-firmware-raspi2 (4-0ubuntu2) hirsute; urgency=medium

  * Add aliases and diversions for brcmfmac43455 configuration on the
    Raspberry Pi Compute Module 4, and 400 (LP: #1912905)

 -- Dave Jones <dave.jones@canonical.com>  Fri, 12 Mar 2021 15:03:37 +0000

linux-firmware-raspi2 (4-0ubuntu1) hirsute; urgency=medium

  * Added diversions for all wifi firmware blobs (LP: #1918013)
  * New upstream boot firmware release, 1.20210303
  * New upstream bluetooth firmware release, 1.2-4+rpt8

    [ Phil Elwell ]
    - Second Spectra fix for CYW43455 (CVE-2020-10370)
      - Original firmware name: BCM4345C0_003.001.025.0174.0342.hcd

  * New upstream wifi firmware release, 1:20190114-1+rpt11

    [ Serge Schneider ]
    - Update CYW43455 firmware
      - brcm/brcmfmac43455-sdio.bin 7.45.229
      - See: https://github.com/raspberrypi/linux/issues/3849

 -- Dave Jones <dave.jones@canonical.com>  Thu, 11 Mar 2021 14:19:26 +0000

linux-firmware-raspi2 (3-0ubuntu2) hirsute; urgency=medium

  * Add wifi configuration file for CM4

 -- Dave Jones <dave.jones@canonical.com>  Thu, 21 Jan 2021 16:21:28 +0000

linux-firmware-raspi2 (3-0ubuntu1) hirsute; urgency=medium

  * New upstream boot firmware release, 1.20210108
  * New upstream bluetooth firmware release, 1.2-4+rpt7

    [ Phil Elwell ]
    - Bug fix CYW43455 firmware
      - This update fixes the failure of CYW43455 to accept BLE connections.
      - Original firmware name: BCM4345C0_003.001.025.0171.0339.hcd
      - See: https://github.com/raspberrypi/linux/issues/3689

    [ Phil Elwell ]
    - Add BCM43430B0.hcd

  * New upstream wifi firmware release, 1:20190114-1+rpt10

    [ Phil Elwell ]
    - New clm_blob for BCM43456
      - An updated clm_blob to open up the 80MHz channels.
    - Use BCM43456 clm_blob on CYW43455
      - The previous CYW43455 clm_blob provides limited access to the higher
        5GHz channels (100+) - the BCM43456 (surprisingly) seems to work and
        doesn't have this problem.

    [ Phil Elwell ]
    - Add BCM43436 firmware
      - brcm/brcmfmac43436-sdio.bin 9.88.4.65
      - brcm/brcmfmac43436-sdio.clm_blob
      - brcm/brcmfmac43436-sdio.txt

 -- Dave Jones <dave.jones@canonical.com>  Tue, 12 Jan 2021 15:38:07 +0000

=== debian/rules ===
--- 
+++ 
@@ -39,7 +39,7 @@
 	# Don't strip anything; it's all pre-built binary blobs and some of
 	# it is foreign architecture anyway
 
-BOOTCOMMIT:= 1.20210303
+BOOTCOMMIT:= 1.20210831
 BOOTFILES := \
 	LICENCE.broadcom \
 	bootcode.bin \

## linux-firmware-raspi2 6

=== debian/changelog ===
linux-firmware-raspi2 (6-0ubuntu0~20.04.1) focal; urgency=medium

  * Backport to focal
    - New upstream boot firmware release, 1.20211118
    - New upstream wifi firmware release, 20210315-3+rpt4 (LP: #1950633)

      [ Phil Elwell ]
      - Add 43438 firmware 7.45.98.118 + external clm_blob
      - Add 43455 firmware 7.45.241 and clm_blob
      - Add "minimal" firmware for AP+STA mode
      - Add 43436S firmware
        - Future Zero 2 W boards will have an alternative version of 43436
          that should have different firmware, named brcmfmac43436s-sdio
      - Update the Cypress 43455 WLAN firmware to 7.45.241, and include the
        new clm_blob with all-zero regrevs (tried previously but with a bad
        blob)

    - Added diversions for new 43436s firmware (including overrides for any
      future external clm_blob)
    - Add autopkgtest for co-existence with linux-firmware (LP: #1927711)

 -- Dave Jones <dave.jones@canonical.com>  Thu, 27 Jan 2022 13:31:58 +0000

linux-firmware-raspi2 (4-0ubuntu0~20.04.1) focal; urgency=medium

  * Backport to focal (LP: #1925971)
    - Add aliases and diversions for brcmfmac43455 configuration on the
      Raspberry Pi Compute Module 4, and 400 (LP: #1912905)

    - Added diversions for all wifi firmware blobs (LP: #1918013)
    - New upstream boot firmware release, 1.20210303
    - New upstream bluetooth firmware release, 1.2-4+rpt8

      [ Phil Elwell ]
      - Second Spectra fix for CYW43455 (CVE-2020-10370)
        - Original firmware name: BCM4345C0_003.001.025.0174.0342.hcd

    - New upstream wifi firmware release, 1:20190114-1+rpt11

      [ Serge Schneider ]
      - Update CYW43455 firmware
        - brcm/brcmfmac43455-sdio.bin 7.45.229
        - See: https://github.com/raspberrypi/linux/issues/3849

 -- William 'jawn-smith' Wilson <william.wilson@canonical.com>  Fri, 23 Apr 2021 16:05:55 -0500

linux-firmware-raspi2 (3-0ubuntu2~20.04.1) focal; urgency=medium

  * Backport to focal (LP: #1911687)
  * Add wifi configuration file for CM4

 -- Dave Jones <dave.jones@canonical.com>  Thu, 21 Jan 2021 16:21:28 +0000

linux-firmware-raspi2 (3-0ubuntu1~20.04.1) focal; urgency=medium

  * Backport to focal (LP: #1911687)
  * New upstream boot firmware release, 1.20210108
  * New upstream bluetooth firmware release, 1.2-4+rpt7

    [ Serge Schneider ]
    - This BCM43438 and BCM43455 Bluetooth firmware updates work around most
      of the report "Spectra" class of vulnerabilities. CVE-2020-10370 will be
      addressed in a follow-up release.
    - Add BCM4345C5.hcd

    [ Phil Elwell ]
    - Bug fix CYW43455 firmware
      - This update fixes the failure of CYW43455 to accept BLE connections.
      - Original firmware name: BCM4345C0_003.001.025.0171.0339.hcd
      - See: https://github.com/raspberrypi/linux/issues/3689

    [ Phil Elwell ]
    - Add BCM43430B0.hcd

  * New upstream wifi firmware release, 1:20190114-1+rpt10

    [ Phil Elwell ]
    - Add BCM43456 firmware
      - brcm/brcmfmac43456-sdio.bin 7.84.17.1
      - brcm/brcmfmac43456-sdio.clm_blob
      - brcm/brcmfmac43456-sdio.txt

    [ Phil Elwell ]
    - New clm_blob for BCM43456
      - An updated clm_blob to open up the 80MHz channels.
    - Use BCM43456 clm_blob on CYW43455
      - The previous CYW43455 clm_blob provides limited access to the higher
        5GHz channels (100+) - the BCM43456 (surprisingly) seems to work and
        doesn't have this problem.

    [ Phil Elwell ]
    - Add BCM43436 firmware
      - brcm/brcmfmac43436-sdio.bin 9.88.4.65
      - brcm/brcmfmac43436-sdio.clm_blob
      - brcm/brcmfmac43436-sdio.txt

  [ Dave Jones ]
  * Change packaging to use multi-upstream tarballs
  * Add diversion for BCM43430 binary blob
  * Bumped compat to 11 and fixed dh_strip issue
  * Rename BCM43456 configuration to include d-t compatible suffix
  * Replaced postinst with flash-kernel trigger (relates to LP: #1895137)

  [ Dimitri John Ledkov ]
  * Replace source tarballs from forked/merged RPi-Distro packages, to a
    3.0 quilt package that has empty orig tarball, and only includes the
    matching files shipped by the package, as component tarballs, without
    duplicating linux-firmware. See get-orig-source target. The resulting
    .deb is identical to the previous one, this only corrects the source
    package contents.
    Components are at:
     - boot - 1.20200902
     - bluez - c317a5c56847d18faf43e531f35c1661f1134046
     - nofree (wifi) - 98e815735e2c805d65994ccc608f399595b74438
  * Drop multiverse/ section for promotion to restricted.

  [ Dave Jones ]
  * Add extra copy of the BCM43456 wifi configuration

 -- Dave Jones <dave.jones@canonical.com>  Tue, 12 Jan 2021 15:38:07 +0000

=== debian/control ===
--- 
+++ 
@@ -10,6 +10,7 @@
 Package: linux-firmware-raspi2
 Architecture: armhf arm64
 Depends: ${misc:Depends}
+Breaks: flash-kernel (<<3.103)
 Description: Raspberry Pi 2/3/4 GPU firmware and bootloaders
  This package contains all the proprietary files necessary to boot a
  Raspberry Pi 2/3/4 board.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# main packaging script based on dh7 syntax
%:
	dh $@

override_dh_install:
	dh_install

	ln -s ../cypress/cyfmac43430-sdio.bin \
		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43430-sdio.bin
	ln -s ../cypress/cyfmac43430-sdio.clm_blob \
		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43430-sdio.clm_blob
	ln -s brcmfmac43430-sdio.txt \
		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43430-sdio.raspberrypi,3-model-b.txt
	ln -s brcmfmac43430-sdio.txt \
		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43430-sdio.raspberrypi,model-zero-w.txt

	ln -s ../cypress/cyfmac43455-sdio.bin \
		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.bin
	ln -s ../cypress/cyfmac43455-sdio.clm_blob \
		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.clm_blob
	ln -s brcmfmac43455-sdio.txt \
		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.raspberrypi,3-model-a-plus.txt
	ln -s brcmfmac43455-sdio.txt \
		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.raspberrypi,3-model-b-plus.txt
	ln -s brcmfmac43455-sdio.txt \
		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.raspberrypi,4-model-b.txt
	ln -s brcmfmac43455-sdio.txt \
		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.raspberrypi,4-compute-module.txt
	ln -s brcmfmac43455-sdio.txt \
		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43455-sdio.raspberrypi,400.txt

	ln -s brcmfmac43456-sdio.txt \
		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43456-sdio.raspberrypi,4-model-b.txt
	ln -s brcmfmac43456-sdio.txt \
		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43456-sdio.raspberrypi,4-compute-module.txt
	ln -s brcmfmac43456-sdio.txt \
		debian/linux-firmware-raspi2/lib/firmware/brcm/brcmfmac43456-sdio.raspberrypi,400.txt

override_dh_strip:
	# Don't strip anything; it's all pre-built binary blobs and some of
	# it is foreign architecture anyway

BOOTCOMMIT:= 1.20211118
BOOTFILES := \
	LICENCE.broadcom \
	bootcode.bin \
	fixup.dat \
	fixup4.dat \
	fixup4cd.dat \
	fixup4db.dat \
	fixup4x.dat \
	fixup_cd.dat \
	fixup_db.dat \
	fixup_x.dat \
	start.elf \
	start4.elf \
	start4cd.elf \
	start4db.elf \
	start4x.elf \
	start_cd.elf \
	start_db.elf \
	start_x.elf

BTCOMMIT:= e7fd166981ab4bb9a36c2d1500205a078a35714d
BTFILES := \
	broadcom/BCM43430A1.hcd \
	broadcom/BCM4345C0.hcd \
	broadcom/BCM4345C5.hcd \
	broadcom/BCM43430B0.hcd

WIFICOMMIT:= 99d5c588e95ec9c9b86d7e88d3cf85b4f729d2bc
WIFIFILES := \
	LICENSE \
	brcm/brcmfmac43430-sdio.txt \
	brcm/brcmfmac43436-sdio.bin \
	brcm/brcmfmac43436-sdio.clm_blob \
	brcm/brcmfmac43436-sdio.txt \
	brcm/brcmfmac43436s-sdio.bin \
	brcm/brcmfmac43436s-sdio.txt \
	brcm/brcmfmac43455-sdio.txt \
	brcm/brcmfmac43456-sdio.bin \
	brcm/brcmfmac43456-sdio.clm_blob \
	brcm/brcmfmac43456-sdio.txt \
	cypress/README.txt \
	cypress/cyfmac43430-sdio.bin \
	cypress/cyfmac43430-sdio.clm_blob \
	cypress/cyfmac43455-sdio-minimal.bin \
	cypress/cyfmac43455-sdio.bin \
	cypress/cyfmac43455-sdio.clm_blob

# get-orig-file,output-dir,source-file,repo-url
get-orig-file = mkdir -p $(1)/$(dir $(2)) ; wget -O $(1)/$(2) -- $(3)/$(2) ;

get-orig-source:
	rm -rf boot bluez nonfree

	set -x; $(foreach file,$(BOOTFILES),$(call get-orig-file,boot,$(file),\
		https://github.com/raspberrypi/firmware/raw/$(BOOTCOMMIT)/boot))
	set -x; $(foreach file,$(BTFILES),$(call get-orig-file,bluez,$(file),\
		https://github.com/RPi-Distro/bluez-firmware/raw/$(BTCOMMIT)))
	set -x; $(foreach file,$(WIFIFILES),$(call get-orig-file,nonfree,$(file),\
		https://github.com/RPi-Distro/firmware-nonfree/raw/$(WIFICOMMIT)/debian/config/brcm80211))

	mkdir $(DEB_SOURCE)-$(DEB_VERSION_UPSTREAM)
	tar -czf ../$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM).orig.tar.gz $(DEB_SOURCE)-$(DEB_VERSION_UPSTREAM)
	tar -czf ../$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM).orig-boot.tar.gz boot/
	tar -czf ../$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM).orig-bluez.tar.gz bluez/
	tar -czf ../$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM).orig-nonfree.tar.gz nonfree/
	rmdir $(DEB_SOURCE)-$(DEB_VERSION_UPSTREAM)

=== debian/tests/control ===
# This trivial test simply installs both linux-firmware and
# linux-firmware-raspi2 to check that the diversions of the latter co-exist
# happily with the files of the former

Depends: linux-firmware-raspi2, linux-firmware
Test-Command: echo linux-firmware and linux-firmware-raspi2 co-exist
